local fs = require("filesystem")
local unsrl = require("serialization").unserialize
local term = require("term")

local url = "https://raw.githubusercontent.com/cc-ru/ut2-server/master/"

if not fs.exists("/home/ut2-serv") then
  io.write("Creating directories... ")
  fs.makeDirectory("/home/ut2-serv")
  print("OK")
end

io.write("Downloading manifest... ")
os.execute("wget -fq " .. url .. "manifest /home/ut2-serv/manifest")
print("OK")

io.write("Reading manifest... ")
local f = io.open("/home/ut2-serv/manifest", "r")
local manifest = unsrl(f:read("*a"))
f:close()
print("OK")

local i = 1
print("Downloading files... [0/" .. #manifest.files .. "]")
for _, file in pairs(manifest.files) do
  local path = fs.concat("/home/ut2-serv/", file.url)
  term.clearLine()
  io.write("  " .. file.url .. " to " .. fs.path(path))
  local x, y = term.getCursor()
  term.setCursor(1, y - 1)
  term.clearLine()
  io.write("Downloading files... [" .. i .. "/" .. #manifest.files .. "]")
  term.setCursor(1, y)
  if not fs.exists(fs.path(path)) then
    fs.makeDirectory(fs.path(path))
  end
  os.execute("wget -fq " .. url .. file.url .. " " .. path)
  i = i + 1
end
local x, y = term.getCursor()
term.clearLine()
term.setCursor(1, y - 1)
term.clearLine()
print("Downloading files... OK")
io.write("Removing previous version... ")
os.execute("hpm remove -yq ut2-serv")
print("OK")
io.write("Installing... ")
os.execute("hpm install -lyq /home/ut2-serv")
print("OK")
print("Done.")