local term = require('term')
local com = require('component')
local gpu = com.gpu

local frame = {
  "    00        24        49        6D        92        B6        DB        FF    ",
  "004080C0FF004080C0FF004080C0FF004080C0FF004080C0FF004080C0FF004080C0FF004080C0FF",
  "                                                                                ",
  "                                                                                ",
  "                                                                                ",
  "                                                                                ",
  "                                                                                ",
  "                                                                                ",
  "004080C0FF004080C0FF004080C0FF004080C0FF004080C0FF004080C0FF004080C0FF004080C0FF",
  "    00        24        49        6D        92        B6        DB        FF    ",
  "",
  "0F1E2D3C4B5A69788796A5B4C3D2E1F0"
}

local red = { 0x00, 0x33, 0x66, 0x99, 0xCC, 0xFF }
local green = { 0x00, 0x24, 0x49, 0x6D, 0x92, 0xB6, 0xDB, 0xFF }
local blue = { 0x00, 0x40, 0x80, 0xC0, 0xFF }
local gray = { 0x0F, 0x1E, 0x2D, 0x3C, 0x4B, 0x5A, 0x69, 0x78, 0x87, 0x96, 0xA5, 0xB4, 0xC3, 0xD2, 0xE1, 0xF0 }

term.clear()
term.setCursor(1, 1)
gpu.setForeground(0xFFFFFF)
for i=1, #frame do print(frame[i]) end

for r = 1, #red do
  term.setCursor(1, 2 + r)
  for g = 1, #green do
    for b = 1, #blue do
      gpu.setForeground(red[r] * 256 * 256 + green[g] * 256 + blue[b])
      io.write("██")
    end
  end
end

term.setCursor(1, 11)
for g = 1, #gray do
  gpu.setForeground(gray[g] * 256 * 256 + gray[g] * 256 + gray[g])
  io.write("██")
end

print("\n\n")